--- linux-3.9/arch/arm/boot/Makefile.orig	2013-04-30 14:17:51.285847709 +0200
+++ linux-3.9/arch/arm/boot/Makefile	2013-04-30 14:44:04.656334857 +0200
@@ -51,8 +51,13 @@
 $(obj)/compressed/vmlinux: $(obj)/Image FORCE
 	$(Q)$(MAKE) $(build)=$(obj)/compressed $@
 
-$(obj)/zImage:	$(obj)/compressed/vmlinux FORCE
+dtbfile := $(shell echo $(CONFIG_ARM_APPENDED_DTB_FILE))
+quiet_cmd_append = APPEND  $(dtbfile)  $@
+      cmd_append = (cat /dev/null $(dtbfile) >> $@)
+
+$(obj)/zImage:	$(obj)/compressed/vmlinux $(dtbfile) FORCE
 	$(call if_changed,objcopy)
+	$(call if_changed,append)
 	@$(kecho) '  Kernel: $@ is ready'
 
 endif
--- linux-3.9/arch/arm/Kconfig.orig	2013-04-29 02:36:01.000000000 +0200
+++ linux-3.9/arch/arm/Kconfig	2013-04-30 20:59:50.981471349 +0200
@@ -2013,6 +2013,16 @@
 	  location into r2 of a bootloader provided DTB is always preferable
 	  to this option.
 
+config ARM_APPENDED_DTB_FILE
+	string "DTB file"
+	depends on ARM_APPENDED_DTB
+	default ""
+	help
+	  This gives the name of file from the build directory to append
+	  to the zImage after it has been built.
+
+	  If you are not sure, leave it blank.
+
 config ARM_ATAG_DTB_COMPAT
 	bool "Supplement the appended DTB with traditional ATAG information"
 	depends on ARM_APPENDED_DTB
